@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION
SETLOCAL ENABLEEXTENSIONS
::-
::- bExtract.cmd - small batch file by jaclaz
::- to extract the <*whatever*> makes a .iso file bootable
::- release 0.04 04 September 2010
::- As usual, thanks go to cdob for the help, hints and support
::-
::- Usage:
::- bExtract.cmd <filename>
::-
::- this batch requires a number of third party .exe's, use 
::- bExtract.cmd /? to list them
::.
::. Usage:
::. bExtract.cmd <filename>
::. Dependencies:
::.
::. isoinfo (part of CDRTOOLS) version 3.00-Win32 (and it's .dll dependencies)
::. http://www.student.tugraz.at/thomas.plank/
::. 
::. fsz and dsfo (part of DSFOK toolkit):
::. http://members.ozemail.com.au/~nulifetv/freezip/freeware/
::. http://members.ozemail.com.au/~nulifetv/freezip/freeware/dsfok.zip
::.
::. gsar
::. http://home.online.no/~tjaberg/
::. http://home.online.no/~tjaberg/gsar121.zip
::.
::. dumphex
::. http://rbach.priv.at/DumpHex/
CLS
IF %1.==. MORE %~dpnx0 |FIND "::-"|FIND /V "FIND"&GOTO :END
IF %1.==/?. MORE %~dpnx0 |FIND "::."|FIND /V "FIND"&&GOTO :END
FOR %%A IN (DUMPHEX.EXE GSAR.EXE DSFO.EXE ISOINFO.EXE FSZ.EXE) DO IF NOT EXIST %%A ECHO %%A NOT FOUND!&GOTO :END


SET Source=%~dpnx1
SET Source_name=%~nx1
SET Destination=%~dp1%~n1_Boot
IF NOT EXIST %Destination% MD %Destination%

ECHO.
REM isoinfo.exe -d -i %Source%
FOR /F "tokens=2 delims= " %%A IN ('isoinfo.exe -d -i %Source% 2^>nul ^|FIND "Bootid" ') DO (
SET /A Bootable=%%A
)

IF NOT %Bootable%.==88. (
ECHO NOT a bootable .iso
PAUSE
GOTO :EOF
)

FOR /F "tokens=3,* delims= " %%A IN ('isoinfo.exe -d -i %Source% 2^>nul ^|FIND "Boot media" ') DO (
SET B_media=%%A
SET Media_Type=%%B
IF %%A.==0. GOTO :No_emulation
IF %%A.==4. GOTO :HD_emulation
GOTO :floppy_emulation
)


:floppy_emulation
FOR /F "tokens=1,2,3 delims= " %%A IN ('isoinfo.exe -d -i %Source% 2^>nul ^|FIND "Bootoff" ') DO (
SET B_offset=%%C
)
IF %B_media%==1 SET B_size=1228800
IF %B_media%==2 SET B_size=1474560
IF %B_media%==3 SET B_size=2949120
SET /A D_offset=%B_offset%*2048
ECHO.
ECHO Attempting to extract %Media_Type% with size %B_size% as Boot_floppy.ima
ECHO.
IF EXIST %Destination%\Boot_floppy.ima DEL %Destination%\Boot_floppy.ima
DSFO.EXE %Source% %D_offset% %B_size% %Destination%\Boot_floppy.ima
ECHO.
CALL :Get_MKI
FOR /F "skip=2 tokens=*" %%A IN ('DIR %Destination% ^|FIND /V "<DIR>" ') DO ECHO %%A
GOTO :End

:HD_emulation
::========================================================
::| WARNING! Limit is  2147483647 i.e. 7FFFFFF   WARNING! |
::========================================================
FOR /F "tokens=1,2,3 delims= " %%A IN ('isoinfo.exe -d -i %Source% 2^>nul ^|FIND "Bootoff" ') DO (
SET B_offset=%%C
)
SET /A D_offset=%B_offset%*2048
CALL :Get_LBA S 1 454
CALL :Get_LBA S 2 470
CALL :Get_LBA S 3 486
CALL :Get_LBA S 4 502
CALL :Get_LBA E 1 458
CALL :Get_LBA E 2 474
CALL :Get_LBA E 3 490
CALL :Get_LBA E 4 506
SET bubble_S=
CALL :Do_bubble
SET /A B_size=!LBA_S_%bubble_I%!+!LBA_E_%bubble_I%!
SET /A B_size=%B_size%*512
ECHO Attempting to extract %Media_Type% with size %B_size% as Boot_HD.img
ECHO.
CALL :check_size
IF  /I NOT %Confirm%.==YES. GOTO :End
ECHO.
IF EXIST %Destination%\Boot_HD.img DEL %Destination%\Boot_HD.img
DSFO.EXE %Source% %D_offset% %B_size% %Destination%\Boot_HD.img
ECHO.
CALL :Get_MKI
FOR /F "skip=2 tokens=*" %%A IN ('DIR %Destination% ^|FIND /V "<DIR>" ') DO ECHO %%A
GOTO :End

:No_emulation
FOR /F "tokens=1,2,3 delims= " %%A IN ('isoinfo.exe -d -i %Source% 2^>nul ^|FIND "Bootoff" ') DO (
SET B_offset=%%C
)
FOR /F "tokens=1,* delims=[;/" %%A IN ('isoinfo.exe -l -i %Source% 2^>nul') DO (
IF "%%A"=="Directory listing of " SET B_path=%%B
FOR /F "tokens=1,3,4 delims=; " %%C IN ("%%B") DO (
IF "%%C"=="%B_offset%" (
ECHO %%A [%%B
SET B_file=%%D
IF NOT %%E.==. SET B_version=;%%E
FOR /F "tokens=5 delims= " %%# IN ("%%A") DO SET B_size=%%#
GOTO :Found
)
)
)
ECHO Ooops, can't find the bootsector file.
ECHO.
PAUSE
GOTO :EOF

:Found
SET B_path_DOS=\%B_path:/=\%
ECHO.
ECHO No Emulation Boot Image found:
ECHO %B_path_DOS%%B_file%%B_version% - size %B_size% bytes
ECHO.
ECHO Attempting to extract %Media_Type% with size %B_size% bytes as %B_file%%
SET /A B_offset_bytes=%B_offset%*2048

CALL :check_size


:Do_extract
IF  /I NOT %Confirm%.==YES. GOTO :End
ECHO.
REM isoinfo -x /%B_path%%B_file%%B_version% -i %Source% > %Destination%\%B_file% >nul 2>&1
REM DSFO %Destination%\%B_file% 0 0 NUL
IF EXIST %Destination%\%B_file% DEL %Destination%\%B_file%
DSFO %Source% %B_offset_bytes% %B_size% %Destination%\%B_file%
FOR /F "tokens=*" %%A IN ('DIR %Destination% ^|FIND  "%B_file%" ') DO ECHO %%A
FOR /F "skip=2 tokens=*" %%A IN ('DIR %Destination% ^|FIND /V "<DIR>" ') DO ECHO %%A
CALL :Get_MKI



:End
ECHO.
PAUSE

GOTO :EOF

:Get_MKI
SET MKI_File=Rebuild.txt
SET gsarstring=gsar -b -s:x00:x00:x4D:x4B:x49:x20
FOR /F "tokens=3 delims=:" %%A IN ('%gsarstring% %Source%^|FIND "%Source_name%"^| FIND /V "found"') DO (
SET /A MKI=%%A+2
)
IF EXIST %Destination%\%MKI_File% DEL %Destination%\%MKI_File%
IF DEFINED MKI (
DSFO %Source% %MKI% 512 %Destination%\%MKI_File%>nul 2>&1 
) ELSE (
GOTO :EOF
)

SET gsarstring=gsar -b -s:x00
FOR /F "tokens=3 delims=:" %%A IN ('%gsarstring% %Destination%\%MKI_File%^|FIND "%MKI_File%"^| FIND /V "found"') DO (
SET /A File_end=%%A
GOTO :Do_FSZ
)

:Do_FSZ
FSZ %Destination%\%MKI_File% %File_End%>nul 2>&1

FOR /F "tokens=1,* delims= " %%A IN (%Destination%\%MKI_File%) DO (
ECHO.
IF %%A.==MKI. (
ECHO This .ISO file was created with MKISOFS on %%B
) ELSE (
ECHO Version %%A
ECHO.
ECHO with this command line ^(saved in %MKI_File%^):
ECHO.
ECHO MKISOFS %%B
ECHO MKISOFS %%B>%MKI_File%
GOTO :EOF
)
)
GOTO :EOF

:Get_LBA
SET /A LBA_%1_%2_offset=%D_Offset%+%3
For /F "tokens=2,3,4,5 delims= " %%A IN ('dumphex /S!LBA_%1_%2_offset! /L4 %Source% 2^>nul') DO (
SET /A LBA_%1_%2=0x%%D%%C%%B%%A
)
GOTO :EOF

:check_size
IF %B_size% leq 2949120 (
SET Confirm=YES
) ELSE (
SET Confirm=NO
SET /P Confirm=Size of the Boot Image is %B_size%, do you want to extract it? [YES/NO] 
)
GOTO :EOF


:Do_bubble
FOR /L %%A IN (1,1,3) DO (
IF NOT DEFINED bubble_S (
IF !LBA_S_4! geq !LBA_S_%%A! (
SET bubble_S=!LBA_S_4!
SET bubble_I=4
) ELSE ( 
SET bubble_S=!LBA_S_%%A!
SET bubble_I=%%A
)
) ELSE (
IF !LBA_S_%%A!  geq !%bubble_S! SET %bubble_S=!LBA_S_%%A!&SET bubble_I=%%A
)
)
GOTO :EOF